package ch.zhaw.projekt2.turnierverwaltung;

import java.io.Serializable;

public class Person implements Serializable {
    private final String NAME_MATCHING_REGEX = "[a-zA-Z]{1,20}";
    private final String PHONE_MATCHING_REGEX = "[\\+]?[0-9]*";

    private String name;
    private String firstName;
    private String phoneNumber;

    public Person(String firstName, String name, String phoneNumber) throws InvalidNameException, InvalidPhoneNumberException {
        if(!firstName.matches(NAME_MATCHING_REGEX)){
            throw new InvalidNameException("The First name is Invalid.");
        } else if(!name.matches(NAME_MATCHING_REGEX)){
            throw new InvalidNameException("The Last name is Invalid");
        } else if(!phoneNumber.matches(PHONE_MATCHING_REGEX)){
            throw new InvalidPhoneNumberException("The entered Phone Number is invalid.");
        }
        setFirstName(firstName);
        setName(name);
        setPhoneNumber(phoneNumber);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public class InvalidPhoneNumberException extends Exception {
        public InvalidPhoneNumberException() {
            super();
        }

        public InvalidPhoneNumberException(String errorMessage) {
            super(errorMessage);
        }

    }

    @Override
    public String toString(){
        return firstName + " " + name;
    }

}
